// Stereo.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "cv.h"
#include "cvcam.h"
#include "highgui.h"


void stereocallback(IplImage* image1, IplImage* image2)
{

	//convert video#1 from RGB to HSV
	cvCvtColor(image1, image1, CV_RGB2HSV);

	//convert video#2 from RGB to Gray
	IplImage * GRAY = cvCreateImage(cvGetSize(image2),IPL_DEPTH_8U,1);
	cvCvtColor(image2, GRAY, CV_RGB2GRAY);
	cvCvtColor(GRAY, image2, CV_GRAY2RGB);
	cvReleaseImage(&GRAY);


}

int main( int argc, char** argv )
{
	int* out;
	int ncams = cvcamGetCamerasCount( );
	int nselected = cvcamSelectCamera(&out);

	cvNamedWindow("cvcam window ONE", 1);
	HWND hwnd1 = (HWND)cvGetWindowHandle("cvcam window ONE");
	cvcamSetProperty(out[0], CVCAM_PROP_ENABLE, CVCAMTRUE);
	cvcamSetProperty(out[0], CVCAM_PROP_WINDOW, &hwnd1);
	cvcamSetProperty(out[0], CVCAM_STEREO_CALLBACK,stereocallback);

	if ( nselected == 2 ) //if 2 cameras were selected
	{
		cvNamedWindow("cvcam window TWO", 1);
		HWND hwnd2 = (HWND)cvGetWindowHandle("cvcam window TWO");
		cvcamSetProperty(out[1], CVCAM_PROP_ENABLE, CVCAMTRUE);
		cvcamSetProperty(out[1], CVCAM_PROP_WINDOW, &hwnd2); 
		cvcamSetProperty(out[1], CVCAM_STEREO_CALLBACK,stereocallback);
	}

	cvcamInit( ); 
	cvcamStart( );

    cvWaitKey(0);

	cvcamStop( );
	cvcamExit( );
	return 0;
}

